%% FileReadTest04
% reads McSimAPN file through to end. Misses comments because textscan is
% only allowed to run once per line. Reads data into dynamic storage arrays
% if called for (tested for Scope, Userblock, conveyor of 50  items).
clc; clear
% Pattern of Data lines is:
% Type ID# Name XX YY OnOff Displ State An Bn Cn Dn Pn #stored aa bb cc dd
%                                                          pp Value Comment
% if a block uses a Store of data (e.g. B O M U G) data is in next line.

%% Open a file that is in same directory
fid = fopen('TransitSystemA.txt', 'rt');  %open for read text in Windows PC

%% Create Structure to match that in McSimAPN for blocks
B.Type='C'; B.ID=101; B.Name='One'; B.XX=100; B.YY=100; B.OnOff=1; B.Displ=0; B.State=1;
B.An=0; B.Bn=0; B.Cn=0;  B.Dn=0; B.Pn=0; B.stored=0; 
B.aa=0; B.bb=0; B.cc=0; B.dd=0; B.pp=0;  B.Store=[ ];
B.Vn=1; B.Comment='This becomes block 1';
B(1000).Name='B1000'; % create an array of blocks up to 1000

%% Set Format
%   1   2    3  4  5     6     7     8  9 10 11 12 13      14 15 16 17 18 19    20      21 
%Type ID# Name XX YY OnOff Displ State An Bn Cn Dn Pn #stored aa bb cc dd pp Value Comment
%          1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20                                              
Lnformat='%s %f %s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f'  %NOT try read comments

%% Get lines and Load into B-structure.
while ~feof(fid)
  textline = fgetl(fid)
  if ~isempty(textline), blockmarker=textline(1); else blockmarker='N'; end;
  % disp(blockmarker);
  % disp('test for block') % to make sure this line is a block definition.
  if  ((blockmarker == '@') && ischar(textline)),  
    C = textscan(textline,Lnformat,1);
    % disp('Done scan');
    % find block identity (ID) and pick out Type and Name
    if C{2}>=1,
      i=C{2};  B(i).ID = i;
      B(i).Type=textline(2);
      namecell=C{3};   NAMEstring=namecell{1}; B(i).Name=NAMEstring;
      % disp(B(i).Name);
      % Load numeric values to block structures
      B(i).XX=C{4}; B(i).YY=C{5}; B(i).OnOff=C{6}; B(i).Displ=C{7}; B(i).State=C{8};
      B(i).An=C{9}; B(i).Bn=C{10}; B(i).Cn=C{11};  B(i).Dn=C{12}; B(i).Pn=C{13};
      B(i).aa=C{15}; B(i).bb=C{16}; B(i).cc=C{17}; B(i).dd=C{18}; B(i).pp=C{19};
      B(i).Vn=C{20};
      storeload= C{14};  %McSimAPN (Pascal) arrays start with 0
      B(i).stored=storeload; %indexing will start at 1 in Matlab
      if (storeload>=1),
          % B(i).Store(storeload+1)=0;
          textline = fgetl(fid); %read the data line that follows the block
          C = textscan(textline,'%f',(storeload+1)) %makes column vector
          B(i).Store = C{1}' ; %loads C-vector into Store array
      end
      % disp([B(i).ID   B(i).XX   B(i).stored  B(i).Vn])
    end
  end
  % disp('done line')
end

%% Close files
fclose('all');